diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/config.gcc gcc-4.1.1/gcc/config.gcc
--- gcc-4.1.1.orig/gcc/config.gcc	2006-05-09 21:02:29.000000000 +0100
+++ gcc-4.1.1/gcc/config.gcc	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 # GCC target-specific configuration file.
 # Copyright 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005
 # Free Software Foundation, Inc.
+# Copyright (c) 2006  STMicroelectronics.
 
 #This file is part of GCC.
 
@@ -1919,7 +1920,18 @@ sh-*-symbianelf* | sh[12346l]*-*-symbian
 	sh*-*-kaos*)	tm_file="${tm_file} sh/embed-elf.h kaos.h sh/kaos-sh.h"
 			;;
 	sh*-*-netbsd*)	tm_file="${tm_file} netbsd.h netbsd-elf.h sh/netbsd-elf.h" ;;
-	*)		tm_file="${tm_file} sh/embed-elf.h" ;;
+	sh*-superh-elf)	if test x$with_libgloss != xno; then
+				with_libgloss=yes
+				tm_file="${tm_file} sh/newlib.h"
+			fi
+			tm_file="${tm_file} sh/embed-elf.h sh/superh.h"
+			tmake_file="${tmake_file} sh/t-superh"
+			extra_options="${extra_options} sh/superh.opt" ;;
+	*)		if test x$with_newlib = xyes \
+			   && test x$with_libgloss = xyes; then
+				tm_file="${tm_file} sh/newlib.h"
+			fi
+			tm_file="${tm_file} sh/embed-elf.h" ;;
 	esac
 	case ${target} in
 	sh5*-*-netbsd*)
@@ -1973,7 +1985,21 @@ sh-*-symbianelf* | sh[12346l]*-*-symbian
 	sh2*)			sh_cpu_target=sh2 ;;
 	*)			sh_cpu_target=sh1 ;;
 	esac
-	sh_cpu_default="`echo $with_cpu|sed s/^m/sh/|tr A-Z_ a-z-`"
+	# did the user say --without-fp ?
+	if test x$with_fp = xno; then
+		case ${sh_cpu_target} in
+		sh5-*media)	sh_cpu_target=${sh_cpu_target}-nofpu ;;
+		sh4al | sh1)	;;
+		sh4a* )		sh_cpu_target=sh4a-nofpu ;;
+		sh4*)		sh_cpu_target=sh4-nofpu ;;
+		sh3*)		sh_cpu_target=sh3 ;;
+		sh2a*)		sh_cpu_target=sh2a-nofpu ;;
+		sh2*)		sh_cpu_target=sh2 ;;
+		*)	echo --without-fp not available for $target: ignored
+		esac
+		tm_defines="$tm_defines STRICT_NOFPU=1"
+	fi
+	sh_cpu_default="`echo $with_cpu|sed 's/^m/sh/'|tr ABCDEFGHIJKLMNOPQRSTUVWXYZ_ abcdefghijklmnopqrstuvwxyz-`"
 	case $sh_cpu_default in
 	sh5-64media-nofpu | sh5-64media | \
 	  sh5-32media-nofpu | sh5-32media | sh5-compact-nofpu | sh5-compact | \
@@ -1987,6 +2013,7 @@ sh-*-symbianelf* | sh[12346l]*-*-symbian
 	sh_multilibs=${with_multilib_list}
 	if test x${sh_multilibs} = x ; then
 		case ${target} in
+		sh64-superh-linux* | \
 		sh[1234]*)	sh_multilibs=${sh_cpu_target} ;;
 		sh64* | sh5*)	sh_multilibs=m5-32media,m5-32media-nofpu,m5-compact,m5-compact-nofpu,m5-64media,m5-64media-nofpu ;;
 		sh-superh-*)	sh_multilibs=m4,m4-single,m4-single-only,m4-nofpu ;;
@@ -1994,10 +2021,13 @@ sh-*-symbianelf* | sh[12346l]*-*-symbian
 		sh*-*-netbsd*)	sh_multilibs=m3,m3e,m4 ;;
 		*) sh_multilibs=m1,m2,m2e,m4,m4-single,m4-single-only,m2a,m2a-single ;;
 		esac
+		if test x$with_fp = xno; then
+			sh_multilibs="`echo $sh_multilibs|sed -e s/m4/sh4-nofpu/ -e 's/,m4-[^,]*//g' -e 's/,m[23]e//' -e s/m2a,m2a-single/m2a-nofpu/ -e s/m5-..m....,//g`"
+		fi
 	fi
-	target_cpu_default=SELECT_`echo ${sh_cpu_default}|tr a-z- A-Z_`
+	target_cpu_default=SELECT_`echo ${sh_cpu_default}|tr abcdefghijklmnopqrstuvwxyz- ABCDEFGHIJKLMNOPQRSTUVWXYZ_`
 	tm_defines=${tm_defines}' SH_MULTILIB_CPU_DEFAULT=\"'`echo $sh_cpu_default|sed s/sh/m/`'\"'
-	sh_multilibs=`echo $sh_multilibs,$sh_cpu_default | sed -e 's/[ 	,/][ 	,]*/ /g' -e 's/ $//' -e s/^m/sh/ -e 's/ m/ sh/g' | tr A-Z_ a-z-`
+	sh_multilibs=`echo $sh_multilibs,$sh_cpu_default | sed -e 's/[ 	,/][ 	,]*/ /g' -e 's/ $//' -e 's/^m/sh/' -e 's/ m/ sh/g' | tr ABCDEFGHIJKLMNOPQRSTUVWXYZ_ abcdefghijklmnopqrstuvwxyz-`
 	for sh_multilib in ${sh_multilibs}; do
 		case ${sh_multilib} in
 		sh1 | sh2 | sh2e | sh3 | sh3e | \
@@ -2008,7 +2038,7 @@ sh-*-symbianelf* | sh[12346l]*-*-symbian
 		sh5-32media | sh5-32media-nofpu | \
 		sh5-compact | sh5-compact-nofpu)
 			tmake_file="${tmake_file} sh/t-mlib-${sh_multilib}"
-			tm_defines="$tm_defines SUPPORT_`echo $sh_multilib|tr a-z- A-Z_`=1"
+			tm_defines="$tm_defines SUPPORT_`echo $sh_multilib|tr abcdefghijklmnopqrstuvwxyz- ABCDEFGHIJKLMNOPQRSTUVWXYZ_`=1"
 			;;
 		*)
 			echo "with_multilib_list=${sh_multilib} not supported."
@@ -2016,7 +2046,7 @@ sh-*-symbianelf* | sh[12346l]*-*-symbian
 			;;
 		esac
 	done
-	if test x${enable_incomplete_targets} == xyes ; then
+	if test x${enable_incomplete_targets} = xyes ; then
 		tm_defines="$tm_defines SUPPORT_SH1=1 SUPPORT_SH2E=1 SUPPORT_SH4=1 SUPPORT_SH4_SINGLE=1 SUPPORT_SH2A=1 SUPPORT_SH2A_SINGLE=1 SUPPORT_SH5_32MEDIA=1 SUPPORT_SH5_32MEDIA_NOFPU=1 SUPPORT_SH5_64MEDIA=1 SUPPORT_SH5_64MEDIA_NOFPU=1"
 	fi
 	use_fixproto=yes
@@ -2740,7 +2770,7 @@ 			  new_val=`grep "^ARM_CORE(\"$val\","
 
 	sh[123456ble]-*-* | sh-*-*)
 		supported_defaults="cpu"
-		case "`echo $with_cpu | tr A-Z_ a-z- | sed s/sh/m/`" in
+		case "`echo $with_cpu | tr ABCDEFGHIJKLMNOPQRSTUVWXYZ_ abcdefghijklmnopqrstuvwxyz- | sed s/sh/m/`" in
 		"" | m1 | m2 | m2e | m3 | m3e | m4 | m4-single | m4-single-only | m4-nofpu )
 			# OK
 			;;
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/configure.ac gcc-4.1.1/gcc/configure.ac
--- gcc-4.1.1.orig/gcc/configure.ac	2006-02-14 16:50:45.000000000 +0000
+++ gcc-4.1.1/gcc/configure.ac	2006-08-10 09:56:05.000000000 +0100
@@ -3,6 +3,7 @@
 
 # Copyright 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006
 # Free Software Foundation, Inc.
+# Copyright (c) 2006  STMicroelectronics.
 
 #This file is part of GCC.
 
@@ -386,6 +387,9 @@ is_release=
 if test x"`cat $srcdir/DEV-PHASE`" != xexperimental; then
   is_release=yes
 fi
+# This compiler has been modified from the official FSF release, and
+# we want to enable sanity checks.
+is_release=
 AC_ARG_ENABLE(werror, 
 [  --enable-werror         enable -Werror in bootstrap stage2 and later], [],
 [if test x$is_release = x ; then
@@ -1323,7 +1327,7 @@ case ${enable_threads} in
     target_thread_file='single'
     ;;
   aix | dce | gnat | irix | posix | posix95 | rtems | \
-  single | solaris | vxworks | win32 )
+  single | solaris | vxworks | win32 | generic)
     target_thread_file=${enable_threads}
     ;;
   *)
@@ -1344,6 +1348,14 @@ if test $thread_file != single; then
   rm -f gthr-default.h
   echo "#include \"gthr-${thread_file}.h\"" > gthr-default.h
   gthread_flags=-DHAVE_GTHR_DEFAULT
+  if test $thread_file != posix; then
+    if test -f $srcdir/gthr-${thread_file}.c; then
+      extra_libgcc_srcs=$srcdir/gthr-${thread_file}.c
+    fi
+    if test -f $srcdir/gthr-objc-${thread_file}.c; then
+      extra_libgcc_srcs="${extra_libgcc_srcs} $srcdir/gthr-objc-${thread_file}.c"
+    fi
+  fi
 fi
 AC_SUBST(gthread_flags)
 
@@ -2122,11 +2134,14 @@ cat > conftest.big <<EOF
 EOF
   # If the assembler didn't choke, and we can objdump,
   # and we got the correct data, then succeed.
+  # The text in the here-document typically retains its unix-style line
+  # endings, while the output of objdump will use host line endings.
+  # Therefore, use diff -b for the comparisons.
   if test x$gcc_cv_objdump != x \
   && $gcc_cv_objdump -s -j .eh_frame conftest.o 2>/dev/null \
      | tail -3 > conftest.got \
-  && { cmp conftest.lit conftest.got > /dev/null 2>&1 \
-    || cmp conftest.big conftest.got > /dev/null 2>&1; }
+  && { diff -b conftest.lit conftest.got > /dev/null 2>&1 \
+    || diff -b conftest.big conftest.got > /dev/null 2>&1; }
   then
     gcc_cv_as_eh_frame=yes
   elif AC_TRY_COMMAND($gcc_cv_as -o conftest.o --traditional-format /dev/null); then
@@ -3407,6 +3422,7 @@ AC_SUBST(xmake_file)
 AC_SUBST(tmake_file)
 AC_SUBST(extra_gcc_objs)
 AC_SUBST(extra_headers_list)
+AC_SUBST(extra_libgcc_srcs)
 AC_SUBST(extra_objs)
 AC_SUBST(extra_parts)
 AC_SUBST(extra_passes)
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/c-opts.c gcc-4.1.1/gcc/c-opts.c
--- gcc-4.1.1.orig/gcc/c-opts.c	2006-01-26 19:06:06.000000000 +0000
+++ gcc-4.1.1/gcc/c-opts.c	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 /* C/ObjC/C++ command line option handling.
    Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
    Contributed by Neil Booth.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -278,6 +279,7 @@       if (lang_fortran && (cl_options[co
       break;
 
     case OPT__output_pch_:
+      CYGPATH (arg);
       pch_file = arg;
       break;
 
@@ -337,11 +339,13 @@       cpp_opts->deps.style = (code == OP
     case OPT_MD:
     case OPT_MMD:
       cpp_opts->deps.style = (code == OPT_MD ? DEPS_SYSTEM: DEPS_USER);
+      CYGPATH (arg);
       deps_file = arg;
       break;
 
     case OPT_MF:
       deps_seen = true;
+      CYGPATH (arg);
       deps_file = arg;
       break;
 
@@ -813,10 +817,12 @@       add_path (xstrdup (arg), AFTER, 0,
 
     case OPT_imacros:
     case OPT_include:
+      CYGPATH (arg);
       defer_opt (code, arg);
       break;
 
     case OPT_iprefix:
+      CYGPATH (arg);
       iprefix = arg;
       break;
 
@@ -825,6 +831,7 @@       add_path (xstrdup (arg), QUOTE, 0,
       break;
 
     case OPT_isysroot:
+      CYGPATH (arg);
       sysroot = arg;
       break;
 
@@ -863,7 +870,10 @@       cpp_set_lang (parse_in, CLK_ASM);
 
     case OPT_o:
       if (!out_fname)
-	out_fname = arg;
+	{
+	  CYGPATH (arg);
+	  out_fname = arg;
+	}
       else
 	error ("output filename specified twice");
       break;
@@ -1228,7 +1238,10 @@ 	  defer_opt (OPT_MT, s + 1);
 
       /* Command line -MF overrides environment variables and default.  */
       if (!deps_file)
-	deps_file = spec;
+	{
+	  CYGPATH (spec);
+	  deps_file = spec;
+	}
 
       deps_append = 1;
       deps_seen = true;
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/cp/ChangeLog.STM gcc-4.1.1/gcc/cp/ChangeLog.STM
--- gcc-4.1.1.orig/gcc/cp/ChangeLog.STM	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.1.1/gcc/cp/ChangeLog.STM	2006-08-10 09:56:05.000000000 +0100
@@ -0,0 +1,5 @@
+2006-06-23  J"orn Rennecke <joern.rennecke@st.com>
+
+	* except.c (expand_start_catch_block): Use correct types for bitwise
+	copy.
+
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/cp/except.c gcc-4.1.1/gcc/cp/except.c
--- gcc-4.1.1.orig/gcc/cp/except.c	2006-02-18 08:37:34.000000000 +0000
+++ gcc-4.1.1/gcc/cp/except.c	2006-08-10 09:56:05.000000000 +0100
@@ -4,6 +4,7 @@    Copyright (C) 1989, 1992, 1993, 1994,
    Contributed by Michael Tiemann <tiemann@cygnus.com>
    Rewritten by Mike Stump <mrs@cygnus.com>, based upon an
    initial re-implementation courtesy Tad Hunt.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -459,7 +460,14 @@       finish_expr_stmt (do_begin_catch (
   else
     {
       tree init = do_begin_catch ();
-      exp = create_temporary_var (ptr_type_node);
+      tree init_type = type;
+
+      /* Pointers are passed by values, everything else by reference.  */
+      if (!TYPE_PTR_P (type))
+	init_type = build_pointer_type (type);
+      if (init_type != TREE_TYPE (init))
+	init = build1 (NOP_EXPR, init_type, init);
+      exp = create_temporary_var (init_type);
       DECL_REGISTER (exp) = 1;
       cp_finish_decl (exp, init, /*init_const_expr=*/false, 
 		      NULL_TREE, LOOKUP_ONLYCONVERTING);
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/flow.c gcc-4.1.1/gcc/flow.c
--- gcc-4.1.1.orig/gcc/flow.c	2005-12-16 09:02:49.000000000 +0000
+++ gcc-4.1.1/gcc/flow.c	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 /* Data flow analysis for GNU compiler.
    Copyright (C) 1987, 1988, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
    1999, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -643,7 +644,8 @@ 	      CLEAR_REG_SET (bb->il.rtl->global
 
       /* If asked, remove notes from the blocks we'll update.  */
       if (extent == UPDATE_LIFE_GLOBAL_RM_NOTES)
-	count_or_remove_death_notes (blocks, 1);
+	count_or_remove_death_notes (blocks,
+				     prop_flags & PROP_POST_REGSTACK ? -1 : 1);
     }
 
   /* Clear log links in case we are asked to (re)compute them.  */
@@ -2926,7 +2928,13 @@ 	  else if (! some_was_live)
 	      if (flags & PROP_REG_INFO)
 		REG_N_DEATHS (regno_first) += 1;
 
-	      if (flags & PROP_DEATH_NOTES)
+	      if (flags & PROP_DEATH_NOTES
+#ifdef STACK_REGS
+		  && (!(flags & PROP_POST_REGSTACK)
+		      || !IN_RANGE (REGNO (reg), FIRST_STACK_REG,
+				    LAST_STACK_REG))
+#endif
+		  )
 		{
 		  /* Note that dead stores have already been deleted
 		     when possible.  If we get here, we have found a
@@ -2939,7 +2947,13 @@ 		    = alloc_EXPR_LIST (REG_UNUSED, reg
 	    }
 	  else
 	    {
-	      if (flags & PROP_DEATH_NOTES)
+	      if (flags & PROP_DEATH_NOTES
+#ifdef STACK_REGS
+		  && (!(flags & PROP_POST_REGSTACK)
+		      || !IN_RANGE (REGNO (reg), FIRST_STACK_REG,
+				    LAST_STACK_REG))
+#endif
+		  )
 		{
 		  /* This is a case where we have a multi-word hard register
 		     and some, but not all, of the words of the register are
@@ -2998,7 +3012,12 @@ 	  for (i = regno_first; i <= regno_last
      here and count it.  */
   else if (GET_CODE (reg) == SCRATCH)
     {
-      if (flags & PROP_DEATH_NOTES)
+      if (flags & PROP_DEATH_NOTES
+#ifdef STACK_REGS
+	  && (!(flags & PROP_POST_REGSTACK)
+	      || !IN_RANGE (REGNO (reg), FIRST_STACK_REG, LAST_STACK_REG))
+#endif
+	  )
 	REG_NOTES (insn)
 	  = alloc_EXPR_LIST (REG_UNUSED, reg, REG_NOTES (insn));
     }
@@ -3764,6 +3783,10 @@ 	  some_was_live |= REGNO_REG_SET_P (pbi
       if (! some_was_live)
 	{
 	  if ((pbi->flags & PROP_DEATH_NOTES)
+#ifdef STACK_REGS
+	      && (!(pbi->flags & PROP_POST_REGSTACK)
+		  || !IN_RANGE (REGNO (reg), FIRST_STACK_REG, LAST_STACK_REG))
+#endif
 	      && ! find_regno_note (insn, REG_DEAD, regno_first))
 	    REG_NOTES (insn)
 	      = alloc_EXPR_LIST (REG_DEAD, reg, REG_NOTES (insn));
@@ -4415,7 +4438,9 @@ struct tree_opt_pass pass_recompute_reg_
 
 /* Optionally removes all the REG_DEAD and REG_UNUSED notes from a set of
    blocks.  If BLOCKS is NULL, assume the universal set.  Returns a count
-   of the number of registers that died.  */
+   of the number of registers that died.
+   If KILL is 1, remove old REG_DEAD / REG_UNUSED notes.  If it is 0, don't.
+   if it is -1, remove them unless they pertain to a stack reg.  */
 
 int
 count_or_remove_death_notes (sbitmap blocks, int kill)
@@ -4487,7 +4512,14 @@ 		        n = hard_regno_nregs[REGNO (re
 		  /* Fall through.  */
 
 		case REG_UNUSED:
-		  if (kill)
+		  if (kill > 0
+		      || (kill
+#ifdef STACK_REGS
+			  && (!REG_P (XEXP (link, 0))
+			      || !IN_RANGE (REGNO (XEXP (link, 0)),
+					    FIRST_STACK_REG, LAST_STACK_REG))
+#endif
+			  ))
 		    {
 		      rtx next = XEXP (link, 1);
 		      free_EXPR_LIST_node (link);
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/fold-const.c gcc-4.1.1/gcc/fold-const.c
--- gcc-4.1.1.orig/gcc/fold-const.c	2006-05-14 05:19:32.000000000 +0100
+++ gcc-4.1.1/gcc/fold-const.c	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 /* Fold a constant sub-tree into a single node for C-compiler
    Copyright (C) 1987, 1988, 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999,
    2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -1817,7 +1818,13 @@   if (REAL_VALUE_ISNAN (r))
   if (! overflow)
     {
       tree lt = TYPE_MIN_VALUE (type);
-      REAL_VALUE_TYPE l = real_value_from_int_cst (NULL_TREE, lt);
+      REAL_VALUE_TYPE l;
+
+      if (TYPE_PRECISION (type) >= 32)
+	l = real_value_from_int_cst (NULL_TREE, lt);
+      else
+	real_from_integer (&l, VOIDmode, (HOST_WIDE_INT) -1 << 31,
+			   (HOST_WIDE_INT) -1, 0);
       if (REAL_VALUES_LESS (r, l))
 	{
 	  overflow = 1;
@@ -1831,7 +1838,14 @@   if (! overflow)
       tree ut = TYPE_MAX_VALUE (type);
       if (ut)
 	{
-	  REAL_VALUE_TYPE u = real_value_from_int_cst (NULL_TREE, ut);
+	  REAL_VALUE_TYPE u;
+
+	  if (TYPE_PRECISION (type) >= 32)
+	    u = real_value_from_int_cst (NULL_TREE, ut);
+	  else
+	    real_from_integer (&u, VOIDmode,
+			       (HOST_WIDE_INT) 32767 << 16 | 65535L,
+			       (HOST_WIDE_INT) 0, 0);
 	  if (REAL_VALUES_LESS (u, r))
 	    {
 	      overflow = 1;
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/gcc.c gcc-4.1.1/gcc/gcc.c
--- gcc-4.1.1.orig/gcc/gcc.c	2006-05-17 19:38:58.000000000 +0100
+++ gcc-4.1.1/gcc/gcc.c	2006-08-10 09:56:05.000000000 +0100
@@ -2,6 +2,7 @@
    Copyright (C) 1987, 1989, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
    1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006 Free Software Foundation,
    Inc.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -1994,6 +1995,7 @@ read_specs (const char *filename, int ma
   char *buffer;
   char *p;
 
+  CYGPATH (filename);
   buffer = load_specs (filename);
 
   /* Scan BUFFER for specs, putting them in the vector.  */
@@ -2216,6 +2218,8 @@       if (*suffix == 0)
 
   if (link_command_spec == 0)
     fatal ("spec file has no spec for linking");
+
+  CYGPATH_FREE (filename);
 }
 
 /* Record the names of temporary files we tell compilers to write,
@@ -2454,9 +2458,12 @@ find_a_file (struct path_prefix *pprefix
   const char *const file_suffix =
     ((mode & X_OK) != 0 ? HOST_EXECUTABLE_SUFFIX : "");
   struct prefix_list *pl;
-  int len = pprefix->max_len + strlen (name) + strlen (file_suffix) + 1;
+  int len;
   const char *multilib_name, *multilib_os_name;
 
+  CYGPATH (name);
+  len = pprefix->max_len + strlen (name) + strlen (file_suffix) + 1;
+  
 #ifdef DEFAULT_ASSEMBLER
   if (! strcmp (name, "as") && access (DEFAULT_ASSEMBLER, mode) == 0)
     return xstrdup (DEFAULT_ASSEMBLER);
@@ -2495,6 +2502,7 @@   if (IS_ABSOLUTE_PATH (name))
       if (access (name, mode) == 0)
 	{
 	  strcpy (temp, name);
+	  CYGPATH_FREE (name);
 	  return temp;
 	}
     }
@@ -2515,7 +2523,10 @@ 		strcat (temp, machine_suffix);
 		strcat (temp, multilib_name);
 		strcat (temp, file_suffix);
 		if (access_check (temp, mode) == 0)
-		  return temp;
+		  {
+		    CYGPATH_FREE (name);
+		    return temp;
+		  }
 	      }
 
 	    /* Now try just the multilib_name.  */
@@ -2523,7 +2534,10 @@ 	    strcpy (temp, pl->prefix);
 	    strcat (temp, machine_suffix);
 	    strcat (temp, multilib_name);
 	    if (access_check (temp, mode) == 0)
-	      return temp;
+	      {
+		CYGPATH_FREE (name);
+	        return temp;
+	      }
 	  }
 
 	/* Certain prefixes are tried with just the machine type,
@@ -2539,14 +2553,20 @@ 		strcat (temp, just_machine_suffix);
 		strcat (temp, multilib_name);
 		strcat (temp, file_suffix);
 		if (access_check (temp, mode) == 0)
-		  return temp;
+		  {
+		    CYGPATH_FREE (name);
+		    return temp;
+		  }
 	      }
 
 	    strcpy (temp, pl->prefix);
 	    strcat (temp, just_machine_suffix);
 	    strcat (temp, multilib_name);
 	    if (access_check (temp, mode) == 0)
-	      return temp;
+	      {
+		CYGPATH_FREE (name);
+	        return temp;
+	      }
 	  }
 
 	/* Certain prefixes can't be used without the machine suffix
@@ -2561,17 +2581,24 @@ 		strcpy (temp, pl->prefix);
 		strcat (temp, this_name);
 		strcat (temp, file_suffix);
 		if (access_check (temp, mode) == 0)
-		  return temp;
+		  {
+		    CYGPATH_FREE (name);
+		    return temp;
+		  }
 	      }
 
 	    strcpy (temp, pl->prefix);
 	    strcat (temp, this_name);
 	    if (access_check (temp, mode) == 0)
-	      return temp;
+	      {
+		CYGPATH_FREE (name);
+	        return temp;
+	      }
 	  }
       }
 
   free (temp);
+  CYGPATH_FREE (name);
   return 0;
 }
 
@@ -3245,18 +3272,48 @@       fatal ("couldn't run '%s': %s", ne
   /* FIXME: make_relative_prefix doesn't yet work for VMS.  */
   if (!gcc_exec_prefix)
     {
-      gcc_exec_prefix = make_relative_prefix (argv[0], standard_bindir_prefix,
-					      standard_exec_prefix);
-      gcc_libexec_prefix = make_relative_prefix (argv[0],
-						 standard_bindir_prefix,
-						 standard_libexec_prefix);
+      /* argv[0] may be a soft link. In this case it may be correct to ignore it and treat it
+	 as the real thing, or we may have to follow the link and find the real installation.
+	 We decide which to do based on whether we can find the target directory (its name
+	 is in spec_machine) without following the links.
+	 If so then assume ALL the files have been linked. In this case it would be the wrong
+	 thing to try and be clever, because the user may be pasting the installation
+	 together with links. Some simple package managers do do this.  */
+      char *temp;
+      gcc_libexec_prefix = make_relative_prefix_ignore_links (argv[0],
+							      standard_bindir_prefix,
+							      standard_libexec_prefix);
+      if (gcc_libexec_prefix)
+	add_prefix (&exec_prefixes, gcc_libexec_prefix, "GCC",
+		    PREFIX_PRIORITY_LAST, 0, 0);
+      if ((temp = find_a_file (&exec_prefixes, spec_machine, R_OK, 0)) == NULL)
+	{
+	  /* the directory was not found so follow the links and hope that solves the problem. */
+	  gcc_exec_prefix = make_relative_prefix (argv[0], standard_bindir_prefix,
+						  standard_exec_prefix);
+	  gcc_libexec_prefix = make_relative_prefix (argv[0],
+						     standard_bindir_prefix,
+						     standard_libexec_prefix);
+	}
+      else
+	{
+	  /* the directory was found so ignore the links and assume the headers/libraries/programs
+	     are all linked from the same place as required.  */
+	  free(temp);
+	  gcc_exec_prefix = make_relative_prefix_ignore_links (argv[0], standard_bindir_prefix,
+							       standard_exec_prefix);
+	}
+
       if (gcc_exec_prefix)
 	putenv (concat ("GCC_EXEC_PREFIX=", gcc_exec_prefix, NULL));
     }
   else
-    gcc_libexec_prefix = make_relative_prefix (gcc_exec_prefix,
-					       standard_exec_prefix,
-					       standard_libexec_prefix);
+    /* Assume the user knew what they were doing when they set GCC_EXEC_PREFIX
+       so ignore any soft links. */
+    gcc_libexec_prefix = make_relative_prefix_ignore_links (gcc_exec_prefix,
+							    standard_exec_prefix,
+							    standard_libexec_prefix);
+
 #else
 #endif
 
@@ -4087,6 +4144,7 @@ 	      if (ch == 'B')
 #ifdef HAVE_TARGET_OBJECT_SUFFIX
 	  argv[i] = convert_filename (argv[i], 0, access (argv[i], F_OK));
 #endif
+	  CYGPATH (argv[i]);
 
 	  if (strcmp (argv[i], "-") != 0 && access (argv[i], F_OK) < 0)
 	    {
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/gthr-generic.c gcc-4.1.1/gcc/gthr-generic.c
--- gcc-4.1.1.orig/gcc/gthr-generic.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.1.1/gcc/gthr-generic.c	2006-08-10 09:56:05.000000000 +0100
@@ -0,0 +1,170 @@
+/* Generic threads supplementary implementation. */
+/* Compile this one with gcc.  */
+/* Copyright (C) 1997, 1999, 2000, 2002, 2006 Free Software Foundation, Inc.
+   Copyright (c) 2006  STMicroelectronics.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING.  If not, write to the Free
+Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
+02110-1301, USA.  */
+
+/* As a special exception, if you link this library with other files,
+   some of which are compiled with GCC, to produce an executable,
+   this library does not by itself cause the resulting executable
+   to be covered by the GNU General Public License.
+   This exception does not however invalidate any other reasons why
+   the executable file might be covered by the GNU General Public License.  */
+
+#define __GTHR_WEAK __attribute__ ((weak))
+
+#include "tconfig.h"
+#include "gthr.h"
+
+#ifndef __gthr_generic_h
+#error "Generic thread support package not supported"
+#endif
+
+/* These are stub functions.  When threading is available, a suitable set of definitions should be linked in.  */
+
+/* Return 1 if thread system is active, 0 if not.  */
+int
+__generic_gxx_active_p (void)
+{
+  return 0;
+}
+
+/* The following functions should return zero on success or the error
+   number.  If the operation is not supported, -1 is returned.
+
+   __generic_gxx_once
+   __generic_gxx_key_create
+   __generic_gxx_key_delete
+   __generic_gxx_setspecific
+   __generic_gxx_mutex_lock
+   __generic_gxx_mutex_trylock
+   __generic_gxx_mutex_unlock
+   __generic_gxx_recursive_mutex_lock
+   __generic_gxx_recursive_mutex_trylock
+   __generic_gxx_recursive_mutex_unlock  */
+
+/* FUNC is a function that should be called without parameters.
+   *ONCE has been initialized to __GTHREAD_ONCE_INIT and is otherwise only
+   used in calls to __generic_gxx_once with FUNC as the second parameter.
+   If __generic_gxx_once succeeds, FUNC will have been called exactly once
+   since the initialization of ONCE through any number of calls of
+   __generic_gxx_once with this pair of ONCE and FUNC values.  */
+int
+__generic_gxx_once (__gthread_once_t *once ATTRIBUTE_UNUSED,
+		    void (*func)(void) ATTRIBUTE_UNUSED)
+{
+  return -1;
+}
+
+/* Assign a key to *KEY that can be used in calls to
+   __generic_gxx_setspecific / __generic_gxx_getspecific.
+   If DTOR is nonzero, and at thread exit the value associated with the key
+   is nonzero, DTOR will be called at thread exit with the value associated
+   with the key as its only argument.  */
+int
+__generic_gxx_key_create (__gthread_key_t *key ATTRIBUTE_UNUSED,
+			  void (*dtor)(void *) ATTRIBUTE_UNUSED)
+{
+  return -1;
+}
+
+/* KEY is a key previously allocated by __generic_gxx_key_create.
+   Remove it from the set of keys known for this thread.  */
+int
+__generic_gxx_key_delete (__gthread_key_t key ATTRIBUTE_UNUSED)
+{
+  return -1;
+}
+
+/* Return thread-specific data associated with KEY.  */
+void *
+__generic_gxx_getspecific (__gthread_key_t key ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
+
+/* Set thread-specific data associated with KEY to PTR.  */
+int
+__generic_gxx_setspecific (__gthread_key_t key ATTRIBUTE_UNUSED,
+		      const void *ptr ATTRIBUTE_UNUSED)
+{
+  return -1;
+}
+
+/* Initialize *MUTEX.  */
+void
+__generic_gxx_mutex_init_function (__gthread_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+}
+
+/* Acquire a lock on *MUTEX.  The behaviour is undefined if a lock on *MUTEX
+   has already been acquired by the same thread.  */
+int
+__generic_gxx_mutex_lock (__gthread_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
+
+/* Try to acquire a lock on *MUTEX.  If a lock on *MUTEX already exists,
+   return an error code.  */
+int
+__generic_gxx_mutex_trylock (__gthread_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
+
+/* A lock on *MUTEX has previously been acquired with __generic_gxx_mutex_lock
+   or __generic_gxx_mutex_trylock.  Release the lock.  */
+int
+__generic_gxx_mutex_unlock (__gthread_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
+
+/* Initialize *MUTEX.  */
+void
+__generic_gxx_recursive_mutex_init_function (__gthread_recursive_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+}
+
+/* Acquire a lock on *MUTEX.  If a lock on *MUTEX has already been acquired by
+   the same thread, succeed.  */
+int
+__generic_gxx_recursive_mutex_lock (__gthread_recursive_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
+
+/* Try to acquire a lock on *MUTEX.  If a lock on *MUTEX has already been
+   acquired by the same thread, succeed.  If any other lock on *MUTEX
+   already exists, return an error code.  */
+int
+__generic_gxx_recursive_mutex_trylock (__gthread_recursive_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
+
+/* A lock on *MUTEX has previously been acquired with
+   __generic_gxx_recursive_mutex_lock or
+   __generic_gxx_recursive_mutex_trylock.  Release the lock.  */
+int
+__generic_gxx_recursive_mutex_unlock (__gthread_recursive_mutex_t *mutex ATTRIBUTE_UNUSED)
+{
+  return 0;
+}
